Section III_Group.

Parameter G : Set.
Parameter op : G -> G -> G.
Parameter e : G.
Parameter inv : G -> G.

Infix "o" := op (at level 35, right associativity).
Notation "a -" := (inv a) (at level 30, right associativity).
Axiom assoc : forall a b c : G, a o (b o c) = (a o b) o c.
Axiom unit : forall a : G, a o e = a /\ e o a = a.
Axiom inverse : forall a : G, a- o a = e /\ a o a- = e.

Lemma unit_l : forall a : G, e o a = a.
Proof.
intro a.
apply (unit a).
Qed.

Lemma unit_r : forall a : G, a o e = a.
Proof.
intro a.
apply (unit a).
Qed.

Lemma inverse_l : forall a : G, a- o a = e.
Proof.
intro a.
apply (inverse a).
Qed.

Lemma inverse_r : forall a : G, a o a- = e.
Proof.
intro a.
apply (inverse a).
Qed.


Lemma cancel_r :
  forall a b c : G, (b o a = c o a -> b = c).
Proof.
intros a b c.
intro H.
assert (b = (b o a) o a-).
rewrite <- assoc.
rewrite inverse_r.
rewrite unit_r.
reflexivity.
rewrite H0.
rewrite H.
rewrite <- assoc.
rewrite inverse_r.
rewrite unit_r.
reflexivity.
Qed.

End III_Group.
